"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function nodeRc(compiler, next) {
    return __awaiter(this, void 0, void 0, function* () {
        const options = compiler.options.rc;
        if (!options) {
            return next();
        }
        const file = yield compiler.readFileAsync('src/res/node.rc');
        Object.keys(options).forEach(key => {
            let value = options[key];
            const isVar = /^[A-Z_]+$/.test(value);
            value = isVar ? value : `"${value}"`;
            file.contents.replace(new RegExp(`VALUE "${key}",*`), `VALUE "${key}", ${value}`);
        });
        return next();
    });
}
exports.default = nodeRc;
