"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function snapshot(compiler, next) {
    return __awaiter(this, void 0, void 0, function* () {
        const snapshotFile = compiler.options.snapshot;
        const warmupScript = compiler.options.warmup;
        if (!snapshotFile) {
            return next();
        }
        yield compiler.replaceInFileAsync('configure', 'def configure_v8(o):', `def configure_v8(o):\n  o['variables']['embed_script'] = '${snapshotFile}'\n  o['variables']['warmup_script'] = '${warmupScript ||
            snapshotFile}'`);
        return next();
    });
}
exports.default = snapshot;
