"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
const Bluebird = require("bluebird");
const rimraf = require("rimraf");
const { promisify } = Bluebird;
const rimrafAsync = promisify(rimraf);
exports.rimrafAsync = rimrafAsync;
function dequote(input) {
    input = input.trim();
    const singleQuote = input.startsWith("'") && input.endsWith("'");
    const doubleQuote = input.startsWith('"') && input.endsWith('"');
    if (singleQuote || doubleQuote) {
        return input.slice(1).slice(0, -1);
    }
    return input;
}
exports.dequote = dequote;
const readFileAsync = promisify(fs_1.readFile);
exports.readFileAsync = readFileAsync;
const writeFileAsync = promisify(fs_1.writeFile);
exports.writeFileAsync = writeFileAsync;
const statAsync = promisify(fs_1.stat);
const isWindows = process.platform === 'win32';
exports.isWindows = isWindows;
function pathExistsAsync(path) {
    return statAsync(path).then(x => true).catch({ code: 'ENOENT' }, () => false);
}
exports.pathExistsAsync = pathExistsAsync;
function isDirectoryAsync(path) {
    return statAsync(path).then(x => x.isDirectory()).catch({ code: 'ENOENT' }, () => false);
}
exports.isDirectoryAsync = isDirectoryAsync;
